<style> html { font-family:  monospace; font-size:18px;max-width: 960px;margin: auto;padding: 20px; } </style>
# piSignage Player2 Setup
Player2 is a new generation piSignage player based on new Raspberry Pi OS and  also available for many more platforms 
based on Debian/Linux and as PWA/Android apps. 

    Make sure video play is supported in chromium browser or mpv using hardware acceleration before chosing the Linux SBC 

## A. Tested platforms and known issues

1. **Raspberry Pi 5 and Pi4 (Bookworm OS - 5.0.1 piSignage image) (beta)**   
    - Raspberry OS Bookworm release, Window manager: wayfire, desktop environment: lxde-pi-wayfire
    - The known issues are documented and updated here [Known Issues](https://help.pisignage.com/hc/en-us/articles/26593998005785-Known-Issues-in-piSignage-for-Raspberry-Pi-5-and-Pi-4-Bookworm-Release-)   
    
   _or_  **Raspberry Pi 4** (with Raspberry Pi Legacy Buster OS - 4.9.0 piSignage image)**  
   - Raspberry OS Buster release, Window manager: mutter, desktop environment: LXDE
   - 4K video support(H.265) only with VLC player full screen
   - 1080p video support on 4K screen could be laggy for few videos     

2. **Intel CPU based NUC and other boards**  
   - OS: Debian 10/11, Window Manager: GNOME Shell/Openbox, desktop environment: LXDE/gdm3 
   - While showing webpages, Desktop Top Panel is visible

3. **Radxa Rock 4C+**  
   - OS: Debian11, Window manager: KWin, Desktop Environment: sddm 
   - Features not yet available: Kiosk, Keypress playlist
   - wifi config with ctrl+N or player webUI will not work, use ctrl+alt+T and nmcli

4. **Odroid N2**   
   - OS: Ubuntu 20.04 Mate desktop,  Window Managaer: metacity/GNOME Shell, desktop environment: lightdm/GNOME 
   - Window TitleBar visible for webpage assets
   - Modifications needed for the hardware(SDL) ticker to work
      1) Remove installed libsdl2 and reinstall.
         `sudo apt remove libsdl2-2.0-0`  
         `sudo apt install libsdl2-2.0-0`  
         `sudo apt install -y libsdl2-dev`  
      2) Navigate to SDL Ticker Directory  
         `cd $HOME/player2/tools/sdl_ticker`  
      3) Run the make script  
         `chmod +x make.sh`  
         `./make.sh`  
   - VLC video player, not hardware accelerated   
   - mpv video player, not hardware accelerated and title bar around the window     

## B. Preparing the OS for piSignage installation  

### Installing on Raspberry OS (Only for Raspberry Pi)

1. Download latest Raspberry Pi OS with desktop (32-bit)  and prepare SD card using Raspberry Pi Imager/Baleno Etcher software  
2. Configure the OS, wifi and wait for the latest upgrade completion
3. If needed, do sudo apt update and sudo apt full-upgrade -y
4. Under raspberry configuration -> interfaces -> enable ssh
4. Under raspberry configuration, select audio output for HDMI (raspi-config -> general -> Audio)

       For Buster OS and Pi 3, issue the following command for chromium browser issue(courtesy: https://forums.raspberrypi.com/viewtopic.php?t=330711#p1990146)   
   
        ```echo 'export CHROMIUM_FLAGS="$CHROMIUM_FLAGS --use-gl=egl"' | sudo tee /etc/chromium.d/egl```    

### Installing on Debian 10/Debian 11/Ubuntu 20(Skip this step for Raspberry Pi hardware)

1. Intel boards
   1. Install debian 10/11 with graphic install and copy any missing firmware files to /lib/firmware/<company>
   2. username and password are set to pi
   3. Use entire disk for partition
   4. Software selection - GNOME, SSH server, Standard system utilities (**unselect other window managers**)
   5. On boot login and open terminal
       `su` 
       `sudo usermod -aG sudo pi`
   6. Logout and login as pi
2. For odroid, just boot Ubuntu mate 20.04  desktop
   1. Select Ubuntu(Default) instead of MATE desktop environment using cog wheel while login
   2. Configure wifi access
   3. sudo snap install chromium

### Installing Debian 11 for radxa Rock4 boards    
   1. Download Debian 11 Desktop image from https://wiki.radxa.com/Rock4/downloads from Official images (*Make sure you select the right board tab*)
   2. Type in "radxa" password to login

## C. Wireless Network Configuration

### For Radxa boards  
   - Configure the wifi using GUI tool
     OR try with NetworkManager CLI nmcli (wpa_supplicant doesn’t seem to work with Radxa)
   
      `sudo nmcli r wifi on`    
      `sudo nmcli dev wifi connect ”<ssid>” password “<password>”`

### For other boards

   - copy missing firmware if any for wifi interface
   - sudo apt install -y dhcpcd5
   - sudo systemctl disable wicd.service (to use dhcpcd and wpa_supplicant as network config tools)
        - Ignore the error if it does not exist
   - sudo rm /etc/xdg/autostart/wicd-tray.desktop
        - Ignore the error if it does not exist
   - Note down wifi and ethernet interface names from sudo ip a command
   - prepare a file /etc/wpa_supplicant/wpa_supplicant.conf
        `ctrl_interface=DIR=/run/wpa_supplicant GROUP=netdev`  
        `update_config=1`  
        `country=IN`  
        `network={`  
        `    ssid="*********"`  
        `    psk="********"`  
        `}`

   - sudo wpa_supplicant -B -i ***wifi interface name for e.g. wlp0s2*** -c /etc/wpa_supplicant/wpa_supplicant.conf
   - sudo apt install rfkill
   - sudo rfkill unblock wlan
   - sudo ln -s /usr/share/dhcpcd/hooks/10-wpa_supplicant /usr/lib/dhcpcd/dhcpcd-hooks/
   - sudo systemctl restart dhcpcd
   - sudo ip a, all interfaces should have dhcp address if connected
   - Make sure /etc/network/interfaces has no entry for ethernet interface or it is set as manual.

## C. User configuration and other configuration (for all platforms)

   - sudo visudo and add the following **as last line**  
    `<username, for e.g. pi>     ALL=(ALL) NOPASSWD:ALL`

   - sudo apt update 
   - sudo apt full-upgrade 
   - Check if chromium-browser or chromium exists (for rockchip chromium is hardware optimized unlike standard chromium)
        - which chromium-browser
        - which chromium
        - If not present, install using following steps
            - sudo apt-get -y install chromium-browser   
            - if chromium-browser package not found 
               - sudo apt-get -y install chromium
               - cd /usr/bin
               - sudo ln -s chromium chromium-browser
   - sudo apt install openssh-server (enable ssh)
        - sudo systemctl enable ssh
        - sudo systemctl start ssh  OR sudo systemctl restart ssh

   - Check if there is a entry in /etc/hosts for hostname as follows, otherwise add the same (you could get the hostname by cat /etc/hostname command)
        `127.0.0.1  <hostname>`
    
  
## Install piSignage software (for all platforms)

1. Download one of the following files to home directory $HOME
   - If you are using a non Raspberry device (Intel NUC, Odroid N2, etc), copy this [piSignage software zip file - legacy ](https://pisignage.com/releases/pi-image-p2-v14.zip)
   - If you are using a Raspberri Pi, copy this [piSignage software zip file - Bookworm releases](https://pisignage.com/releases/pi-image-p2-v20.zip)
1. unzip -o pi-image-p2-v14.zip    (OR unzip -o pi-image-p2-v20.zip)
1. cp player2/build-scripts/install-pisignage.sh .
1. chmod +x install-pisignage.sh
1. chmod +x -R player2/build-scripts
1. chmod +x -R player2/shell-scripts
1. ./install-pisignage.sh
1. Notice the log for any Errors
1. sudo apt update --fix-missing  

## (Optional) If script do not work, Using GUI (dconf-editor or gsettings command), 
   - disable Scrren Lock, Screen Saver, Power management, Screen Dim, Notifications and Appearnace of taskbar for programs like webpage, mpv, vlc players


## Upgrading software with new zip file  (Manual upgrade, not needed for auto upgrade)
1. Copy the pi-image-p2-v14.zip to home directory /home/pi
1. unzip -o pi-image-p2-v14.zip
1. chmod +x -R player2/shell-scripts

**Notes:**
1. If there is no Audio, please refer [help article](https://help.pisignage.com/hc/en-us/articles/13537532490393-View-and-Set-an-Audio-Output-Interface) to select the audio interface
2. If you are stuck and need support for image generation for your hardware, please write to us with hardware type, OS link and error log at support at pisignage.com***









