build-scripts/all-scripts.sh has 

# piSignage for Bookworm OS (Raspberry Pi 5)

Compositor: Wayfire

Wayfire configuration
------

Script: wayfire-scripts/wayfire.ini
Location: ~/.config/wayfire.ini

Highlights:
- Key Mapping
- Display Orientation control
- Screensaver and Display Timeout control
- Autostart control
- Window position management (limited control)


Reference articles:
1) wayfire.ini configuration guide:
https://github.com/WayfireWM/wayfire/tree/master/metadata
https://github.com/WayfireWM/wayfire/wiki/Configuration

2) Decoration: (Not working as expected)
https://github.com/WayfireWM/wayfire/blob/master/metadata/decoration.xml
https://github.com/WayfireWM/wayfire/issues/551#issuecomment-1007068066

3) AutoStart:
https://www.raspberrypi.com/tutorials/how-to-use-a-raspberry-pi-in-kiosk-mode/

4) Screen Timeout:
https://wayfire.org/2019/10/07/Wayfire-0-3.html
https://forums.gentoo.org/viewtopic-p-8604297.html?sid=ea4896b6e474217e64f1be7f8faecfb3

5) Other configurations:
https://www.reddit.com/r/Wayfire/comments/zpszvz/window_overlapping_waybar/



wf-panel configuration (Top Navigation panel)
------

Script: wayfire-scripts/wf-panel-pi.ini
Location: ~/.config/wf-panel-pi.ini

Highlights:
- Hiding Left, Center, Right Widgets like Raspberry Button, Current tabs open, Software updates, bluetooth-wifi controls and clock
- Auto hide the nav bar
- Hide notifications

Reference articles:

1) Hiding the Widgets on Left, Right, Center
https://github.com/WayfireWM/wf-shell/blob/master/wf-shell.ini.example
https://github.com/WayfireWM/wf-shell/blob/master/metadata/panel.xml

2) Keep an eye out for any notifications / popup. This might be helpful to hide if any
https://github.com/WayfireWM/wf-shell/blob/master/metadata/dock.xml


desktop-items configuration 
------

Script: wayfire-scripts/desktop-items.conf
Location: /etc/xdg/pcmanfm/LXDE-pi/desktop-items-0.conf and /etc/xdg/pcmanfm/LXDE-pi/desktop-items-1.conf

Highlights:
- Hiding delete/other desktop icons
- Changing wallpaper to pisignage-logo.png

Default wallpaper location: /usr/share/rpd-wallpaper/fisherman.jpg

cec-ctl commands (TV_ON / TV_OFF control)
------

General Commands

    cec-ctl --device /dev/cec0 --to cec0 <command>

    cec-ctl -d0 -t0 <command>

Configure the Display Adapters as playback devices

    cec-ctl -d0 --playback

Get Power status of connected Displays(TV)

    cec-ctl -s -d0 -t0 --timeout 40000 --give-device-power-status | grep pwr-state

    cec-ctl --device /dev/cec0 -S | grep "Power Status"


Set the Display(TV) to Standby Mode

    cec-ctl -s -d0 -t0 --timeout 20000 --standby


Set the Display(TV) to ON Mode

    cec-ctl -s -d0 -t0 --image-view-on


Set the Device as Active Source 

    cec-ctl -d0 -t0 --image-view-on | grep "Physical Address"

    cec-ctl -s -d0 -t0 --active-source phys-addr=${address}


Assign power state to device

    (standby)
    cec-ctl -d0 -t0 --report-power-status pwr-state=1

    (ON)
    cec-ctl -d0 -t0 --report-power-status pwr-state=0

Get device power status - Standby / ON

    cec-ctl -d0 -t0 --give-device-power-status
    
    cec-ctl -d0 -t0 --give-device-power-status | grep pwr-state
