#!/bin/bash
# IMPORTANT: use $HOME as the base for everything
notify(){
    printf "\n"
    figlet -f digital -c $1
    printf "\n"
}

makeAutoLogin(){
    if [ ! -f /etc/lightdm/lightdm.conf ]; then
        sudo echo "[Seat:*]
#autologin-user=$USER
#autologin-user-timeout=0" | sudo tee /etc/lightdm/lightdm.conf
    fi

    sudo sed -i "s/^\#autologin-user=.*/autologin-user=$USER/" /etc/lightdm/lightdm.conf
    sudo sed -i "s/^\#autologin-user-timeout.*/autologin-user-timeout=0/" /etc/lightdm/lightdm.conf
    sudo sed -i "s/^\#greeter-user=.*/greeter-user=$USER/" /etc/lightdm/lightdm.conf
    sudo sed -i "s/^\#pam-greeter-service=.*/pam-greeter-service=lightdm-autologin/" /etc/lightdm/lightdm.conf
    sudo sed -i "s/^greeter-session=.*/greeter-session=LXDE-pi-wayfire/" /etc/lightdm/lightdm.conf
    #Create a dummy desktop config file for LightDM-pi-wayfire greeter
    sudo cp /usr/share/xgreeters/pi-greeter-wayfire.desktop /usr/share/xgreeters/LXDE-pi-wayfire.desktop
    sudo sed -i "s|^Exec=.*|Exec=/usr/bin/wayfire-pi|" /usr/share/xgreeters/LXDE-pi-wayfire.desktop
}

modifyDesktop(){
    sudo sed 's/.*wallpaper_mode.*/wallpaper_mode=2/' -i $1
    sudo sed 's|.*wallpaper=.*|wallpaper=/home/pi/player2/public/img/pisignage-logo.png|' -i $1
    sudo sed 's/.*show_trash.*/show_trash=0/' -i $1
    sudo sed 's/.*show_mounts.*/show_mounts=0/' -i $1
}

modifyWfpanel(){
    printf '
widgets_left = none
widgets_center = none
widgets_right = none
position=top
icon_size=32
window-list_max_width=200
monitor=0
autohide=true
autohide_duration = 1
background_color = $000000
notifications_autohide_timeout = 0
notifications_critical_in_dnd = false
notifications_icon_size = 0
' | sudo tee -a $1 >/dev/null
}

modifyWayfireini(){
  #beginning of file
  sed -i '1 i\# https://github.com/WayfireWM/wayfire/issues/551#issuecomment-1007068066 \
[core] \
preferred_decoration_mode = server \
' $1

  sed -i '/\[command\]/a binding_screenshot = <ctrl> KEY_P   \
command_screenshot = grimshot --notify save screen /home/pi/screenshot.jpeg  \
binding_nwconfig = <ctrl> KEY_N  \
command_nwconfig = lxterminal --command sudo network-config' $1

  sed -i '/\[idle\]/a # https://wayfire.org/2019/10/07/Wayfire-0-3.html \
#https://forums.gentoo.org/viewtopic-p-8604297.html?sid=ea4896b6e474217e64f1be7f8faecfb3  \
screensaver_timeout = -1' $1


  printf '
[output]
headless_width = 1920
headless_height = 1080

# Syntax to rotate orientation through wayfire.ini
#displayOneConfigStart
[output:HDMI-A-1]
mode = 1920x1080
transform = normal
#displayOneConfigEnd

#displayTwoConfigStart
#displayTwoConfigEnd

# This is not working
# # https://github.com/WayfireWM/wayfire/issues/551#issuecomment-1007068066
[decoration]
border_size = 0
title_height = 0
ignore_views = all

[autostart]
pisignage = bash /home/pi/start.sh

# positioning of ticker, pqiv has to be done using wayfire.ini
[window-rules]
rule-1 = on created if # Chromium Default
rule-2 = on created if # Chromium weblink-0
rule-3 = on created if # Chromium weblink-1
rule-4 = on created if # Chromium weblink-2
rule-5 = on created if # Chromium weblink-3
rule-6 = on created if # Chromium weblink-4
rule-7 = on created if # Chromium kiosk
rule-8 = on created if # Chromium Default-1 for Dual Display
rule-9 = on created if app_id is "swayimg" then move 10 10 # swayimg - to display Logos - supports transparent background
rule-10 = on created if app_id is "ticker" then move 0 1020 # SDL Ticker
rule-11 = # VLC Windowed

# ------------------ TESTING RULES ------------------ #
# rule-101 = on created if app_id is "pqiv" then move 10 10 # working example
# rule-102 = on created if app_id is "lxterminal" then set geometry 10 10 200 200 # working example
# rule-103 = on created if app_id is "ticker" then move 0 1020 # working example
# rule-104 = on created if app_id is "swayimg" then move 10 10

# DISPLAY=:0.0 chromium-browser --window-name="test" https://pisignage.com
# rule-105 = on created if (app_id contains "browser" & title contains "test") then move 500 500 # working example

# DISPLAY=:0.0 chromium-browser --app=https://pisignage.com
# rule-106 = on created if (app_id contains "browser" & title contains "pisignage") then move 200 200 # working example

# DISPLAY=:0.0 chromium-browser --app="https://pisignage.com/homepage/documentation.html#chromeos"
# rule-107 = on created if (app_id contains "browser" & title contains "pisignage" & title contains "homepage" & title contains "documentation" & title contains "html") then move 200 200 # working example

# DISPLAY=:0.0 chromium-browser --app="https://google.com"
# rule-108 = on created if (app_id contains "browser" & title contains "") then move 40 40
# rule-109 = on created if (app_id contains "browser" & title contains "com") then move 100 100
# rule-110 = on created if (app_id contains "browser" & title contains "google") then move 40 40

#DISPLAY=:0.0 cvlc  --no-video-deco  --no-qt-name-in-title --no-video-title-show brand_intro.mp4
# rule-111 = on created if (app_id contains "VLC" | title contains "VLC" | app_id contains "video") then move 0 0
# rule-112 = on created if (title contains "VLC") then move 0 0

# not working
#rule-113 = on created if title is "weblink-0" then set geometry 20 20 200 200
#rule-114 = on created if app_id is "chromium-browser" then set geometry 20 20 200 200
#rule-115 = on created if app_id is "chromium" then set geometry 20 20 200 200
#rule-116 = on created if app_id contains "chromium" then move 10 10
#rule-117 = on created if title contains "Signage" then move 30 30
#rule-118 = on created if app_id contains "browser" then move 50 50
#rule-119 = on created if app_id contains "firefox" then move 10 10
#rule-120 = on created if app_id contains "vlc" then maximize
' | sudo tee -a $1 >/dev/null

}


wayfireSetup(){
    notify "Auto startup script"
    cp $HOME/player2/shell-scripts/start.sh $HOME/
    sudo chmod 777 $HOME/start.sh

    makeAutoLogin

    notify "WF_Panel Setup"
    if [ -f "$HOME/.config/wf-panel-pi.ini" ]
    then
      echo "Copying existing wf-panel-pi.ini to $HOME/.config/wf-panel-pi.ini.bak"
      cp $HOME/.config/wf-panel-pi.ini $HOME/.config/wf-panel-pi.ini.bak
      modifyWfpanel $HOME/.config/wf-panel-pi.ini
    fi

    notify "Wayfire Setup"
    if [ -f "$HOME/.config/wayfire.ini" ]
    then
       echo "Copying existing wayfire.ini to $HOME/.config/wayfire.ini"
       cp $HOME/.config/wayfire.ini $HOME/.config/wayfire.ini.bak
       modifyWayfireini $HOME/.config/wayfire.ini
    fi

    notify "Desktop Setup"
    if [ -f "/etc/xdg/pcmanfm/LXDE-pi/desktop-items-0.conf" ]
    then
        sudo cp /etc/xdg/pcmanfm/LXDE-pi/desktop-items-0.conf /etc/xdg/pcmanfm/LXDE-pi/desktop-items-0.conf.bak
        modifyDesktop /etc/xdg/pcmanfm/LXDE-pi/desktop-items-0.conf
    fi
    if [ -f "/etc/xdg/pcmanfm/LXDE-pi/desktop-items-1.conf" ]
    then
        sudo cp /etc/xdg/pcmanfm/LXDE-pi/desktop-items-1.conf /etc/xdg/pcmanfm/LXDE-pi/desktop-items-1.conf.bak
        modifyDesktop /etc/xdg/pcmanfm/LXDE-pi/desktop-items-1.conf
    fi
    #hide the cursor - instead added plugin below
    #sudo mv /usr/share/icons/PiXflat/cursors/left_ptr /usr/share/icons/PiXflat/cursors/left_ptr.bak

    # install wayfire plugins extra raspbian https://raspberrypi.stackexchange.com/questions/145382/remove-hide-mouse-cursor-when-idle-on-rasbperry-pi-os-bookworm
    sudo apt -y install libglibmm-2.4-dev libglm-dev libxml2-dev libpango1.0-dev libcairo2-dev wayfire-dev libwlroots-dev libwf-config-dev
    sudo apt -y install meson
    git clone https://github.com/seffs/wayfire-plugins-extra-raspbian && cd wayfire-plugins-extra-raspbian
    meson build --prefix=/usr --buildtype=release
    ninja -C build && sudo ninja -C build install

    sudo sed -i '/^plugins/ s/$/ hide-cursor/' /etc/wayfire/defaults.ini
    
    # echo "Other configuration"
    # [ -f /usr/share/themes/PiXflat/gtk-3.0/gtk-contained.css ] && sudo mv /usr/share/themes/PiXflat/gtk-3.0/gtk-contained.css /usr/share/themes/PiXflat/gtk-3.0/gtk-contained.css.bak
    # sudo cp $HOME/player2/build-scripts/wayfire-scripts/gtk.css /usr/share/themes/PiXflat/gtk-3.0/gtk-contained.css
}

notify "Setting up pisignage wayfire"
wayfireSetup
